/*
  CPP_CONTEST=2015
  CPP_PROBLEM=E
  CPP_LANG=CPP+OPENMP
  CPP_PROCESSES_PER_NODE=jupiter 1
*/

//

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>
#include <iostream>
#include <iomanip>    

using namespace std;

float distancia(int n1,int *d1,int n2,int *d2)
{
  float sum=0.;
  int x1,x2,y1,y2;
  for(int i=0;i<2*n1;i+=2)
  {
    x1=d1[i];
    y1=d1[i+1];
    for(int j=0;j<2*n2;j+=2)
    {
      x2=d2[j];
      y2=d2[j+1];
      sum+=(x1>x2?x1-x2:x2-x1);
      sum+=(y1>y2?y1-y2:y2-y1);
#ifdef DEBUG
      cout << "Distancia acumulada paso "<< i << " , " << j << " : "<< sum<<endl;
#endif
    }
  }
  return sum/(n1*n2);
}

float  sec(int S,int *P,int *D)
{
  float opt=1000000.;
  float temp;
  int acum1=0;
  int acum2;
  for(int i=0;i<S;i++)
  {
    acum2=acum1+2*P[i];
    for(int j=i+1;j<S;j++)
    {
       temp=distancia(P[i],&D[acum1],P[j],&D[acum2]);
       acum2+=2*P[j];
       opt=((temp<opt)?temp:opt);
#ifdef DEBUG
      cout << "Distancia conjuntos "<< i << " , " << j << " : "<<temp<< " ; Optimo : " <<opt<<endl;
#endif
    }
    acum1+=2*P[i];
  }
  return opt;      
}

